-----------------------------------------------------------------------------------------------
-- Author: Frosthaven
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------

require "Apollo"
require "GameLib"
require "Window"
 
-- DEFINITION ---------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
local FMRF = {
	debug = false,
}

-- INITIALIZATION -----------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMRF:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function FMRF:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		--none
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

-- EVENTS -------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMRF:OnLoad()
	--we'll fix our roles after the interface has loaded for safety
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "FixRoles", self)
end

-- METHODS ------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMRF:FixRoles()
	local classID = GameLib.GetPlayerUnit():GetClassId()

	if classID == GameLib.CodeEnumClass.Warrior or classID == GameLib.CodeEnumClass.Engineer or classID == GameLib.CodeEnumClass.Stalker then
		MatchingGame.SelectRole(MatchingGame.Roles.Healer, false)
	elseif classID == GameLib.CodeEnumClass.Medic or classID == GameLib.CodeEnumClass.Esper or classID == GameLib.CodeEnumClass.Spellslinger then
		MatchingGame.SelectRole(MatchingGame.Roles.Tank, false)
	end
end

-- CREATE INSTANCE ----------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
local FMRFInst = FMRF:new()
FMRFInst:Init()